# Overview

This interface layer handles the communication between a `IBM Platform LSF Storage/IBM Spectrum Symphony Storage` which are acting as a `NFS Server` and NFS Clients like `Platform LSF Master`, `Spectrum Symphony Master`.
The provider end of this interface provides the NFSStorage service. The consumer/Requires part will be the NFS clients which wants the shared files from the Storage Server.


# Usage

## Provides
Any IBM Platform product having failover feature (master and master-candidates distributed model) will provide this interface. This interface layer will set the following states, as appropriate:

 - `{relation_name}.joined `: The relation is established, but NFS Storage may not yet have provided any connection or service information.

 - `{relation_name}.available` : NFS Storage has provided its service information, and is ready to accept requests from the consumer. The provider ie Storage Server can get the Client IP and Service Details by accessing the below methods:

     - `nfsclient_ip` - Returns a list of private-addresss of the clients connected to the Storage server
     - `nfsclient_service` - Returns a list of unit name of the clients connected to the Storage server


## Requires

Consumers like `Platform LSF Master/Server` or `Spectrum Symphony Master/Node` will require this interface to connect to NFS Storage Server so that they can mount the shared Platform product installation and configuration files. This interface layer will set the following states, as appropriate:

- `{relation_name}.joined` : The consumer charm has been related to a NFS Storage provider. At this point, the charm waits for Storage Server configuration details like hostname and IP Address(private-address).

- `{relation_name}.available` : NFS Storage is now ready for the consumers/nfs clients. The nfs clients charm can access the Storage configuration details using the below methods:

    - `get_hostname()` - returns the hostname of NFS Storage Server
    - `private_address()` - returns the IP Address of NFS Storage Server
