from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes


class nfsstorageProvides(RelationBase):
    # Every unit connecting will get the same information
    scope = scopes.UNIT

    # Use some template magic to declare our relation(s)
    @hook('{provides:nfsstorage}-relation-joined')
    def joined(self):
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.departing')
        conversation.set_state('{relation_name}.joined')

    @hook('{provides:nfsstorage}-relation-changed')
    def changed(self):
        conversation = self.conversation()
        conversation.set_state('{relation_name}.available')

    @hook('{provides:nfsstorage}-relation-departed')
    def departed(self):
        # Remove the joined/available states on charm departure
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.joined')
        conversation.remove_state('{relation_name}.available')
        conversation.set_state('{relation_name}.departing')

    def dismiss_departed(self):
        for conv in self.conversations():
            conv.remove_state('{relation_name}.departing')

    def host_name(self, hostname_storage):
        for conv in self.conversations():
            conv.set_remote(data={
                'hostname_storage': hostname_storage,
            })

    def nfsclient_ip(self):
        ip = []
        for conv in self.conversations():
            ip.append(conv.get_remote('private-address'))
        return ip

    def nfsclient_service(self):
        serv = []
        for conv in self.conversations():
            serv.append(conv.scope)
        return serv
