from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes


class nfsstorageRequires(RelationBase):
    scope = scopes.GLOBAL

    @hook('{requires:nfsstorage}-relation-joined')
    def joined(self):
        self.remove_state('{relation_name}.departing')
        self.set_state('{relation_name}.joined')

    @hook('{requires:nfsstorage}-relation-changed')
    def changed(self):
        self.remove_state('{relation_name}.departing')
        if (str(self.get_remote('hostname_storage')) != "None"):
            self.set_state('{relation_name}.available')

    @hook('{requires:nfsstorage}-relation-departed')
    def departed(self):
        # Remove the joined/available states on charm departure
        self.remove_state('{relation_name}.available')
        self.remove_state('{relation_name}.joined')
        self.set_state('{relation_name}.departing')

    def private_address(self):
        return self.get_remote('private-address')

    def get_hostname(self):
        return self.get_remote('hostname_storage')
