# Overview

This interface layer handles the communication between Platform Master (like IBM Platform LSF, IBM Spectrum Symphony) and Platform Server/Nodes. The provider end of this interface provides the LSF Master/Symphony Master service. The consumer part requires the existence of a provider to function.
This interface also handles communication among Platform Master Peers called Master Candidates. Any IBM Platform product having distributed architecture i.e. master and master-candidates can provide this interface


# Usage

## Provides

This interface layer will set the following states, as appropriate:

  - `{relation_name}.joined` : The relation is established, but Master may not yet have provided any connection or service information.

  - `{relation_name}.available` : Master has provided its connection string information, and is ready to accept requests from the consumer. The provided information can be accessed via the following methods:
      - `host_name()` - will provide the Platform Master hostname details.
      - `notify_server()` - will provide the readiness status flag of Platform Master.


## Requires
Consumers like Platform LSF Server or Spectrum Symphony Node require this interface to connect to Platform Master. This interface layer will set the following states, as appropriate:
  - `{relation_name}.joined` : The consumer charm has been related to a Platform Master provider. At this point, the charm waits for Master configuration details.

  -  `{relation_name}.MasterReConfigReady` : Platform Master is now ready for the consumers. The consumer charm can access the Master configuration details using 
the below methods:

      - `get_hostname()` - hostname of platform master
      - `private_address()` - IP Address(private-address) of platform master
      - `notify_server()` - Readiness status flag of platform master

      Also it provides hostname information to the Provider ie Platform Master using the following method:
     - `set_hostname()` - Provides the hostname of consumer charm to Platform Master



## Peers
This interface allows the peers of the Platform Master deployment to be aware of each other. This interface layer will set the following states, as appropriate:

  - `{relation_name}.joined` - A new peer in the Platform Master service has joined. 

  - `{relation_name}.available` -  It will return a list of units containing the Hostname and IP Address information for cluster members.
This information can be accessed via the below method:
      
      - `get_unithost`
      - `get_unitip`

  - `{relation_name}.departed` - A peer in the Platform Master service has departed. 
